// ==============================================================
//                 ORBITER MODULE: EAGLEHANGAR2
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// EAGLEHANGAR2.cpp
// Control module for EAGLEHANGAR2 vessel class
//
// Notes:
// This is an example for a "minimal" vessel implementation which
// only overloads the clbkSetClassCaps method to define vessel
// capabilities and otherwise uses the default VESSEL class
// behaviour.
// ==============================================================



//#include "orbitersdk.h"
#include "UMmuSDK.h"
#include "UCGOCargoSDK.h" //UCGO 2.0 copy past this line
#include "resource.h"
// ==============================================================
// Some vessel parameters
// ==============================================================
const double PB_FUELMASS = 33000;
const double PB_ISP = 50000;

const double PB_MAXRCSTH = 5e3;//9.9e4
const double PB_MAXHOVERTH =8.5e5;
// Interface for derived vessel class: QJBStar
// ==========================================================

class BELL222: public VESSEL2 {
public:
   BELL222 (OBJHANDLE hObj, int fmodel);
	void clbkSaveState(FILEHANDLE scn);
       void clbkPostCreation (void);
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
 	void DefineAnimations(void); 
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
	void clbkPostStep (double simtt, double simdt, double mjd);
	void clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC);

	void RevertGEAR (void);
		//void RevertRAMP (void);

		void RevertDOOR1 (void);
		void RevertDOOR2 (void);
				void RevertDOOR3 (void);
		void RevertDOOR4 (void);

			//void RevertGEARCOVER (void);

		//void AttachCargo();
    //void DetachCargo();
	 bool clbkLoadVC(int id);


	//void PM_clbkPayloadJettisoned(int slot_idx, OBJHANDLE jettisoned_ship);
	//void PM_clbkVehicleCapsChanged();

//void VLiftCoeff (double aoa, double M, double Re, double *cl, double *cm, double *cd);
//void HLiftCoeff (double beta, double M, double Re, double *cl, double *cm, double *cd);





//char j_name[32];
//	double j_timer;

double ATMD1,ATMadjusted,ATMD2,ATMD3;
enum GEAR_status { GEAR_UP, GEAR_DOWN, GEAR_RAISING, GEAR_LOWERING } GEAR_status,DOOR1_status,DOOR4_status,DOOR3_status,DOOR2_status;

PROPELLANT_HANDLE ph_h[1];
 THRUSTER_HANDLE th_h[15];
 THGROUP_HANDLE thg_h[15];
THRUSTER_HANDLE th_main, th_retro,  th_rcs[4], th_group[2], th_att_rot[4],th_att_lin[4], th_hover[1];

	THGROUP_HANDLE thg_hover;
		void SetUMMUAirlockPos (void);

	void BELL222::SelectCockpitView (int CAM); 


int j,ROTOR,do_attach;

#define BELL222Engines				50
#define BELL222Gear			   	51
#define BELL222Start			   	52


double DOOR3_proc, apd, MAX_GRAP_DIST, CABLEFACTOR, DOOR4_proc,ROTORSTART,ENGINESTART;
enum IGNITION_check { YES_START, NO_START } IGNITION_check;


double LIFT_SPEED,GEAR_proc,ROTOR_proc,ROTOR_SPEED,DOOR1_proc,ROTOR1,ALT,GEARCOVER_proc,STICKX_proc,STICKZ_proc,COLL_proc,DOOR2_proc,ROTORD_SPEED,ROTORD_proc;
//double DOOR2_proc;
//double TCAR_proc; 
double db,simdt,STICK1Z,STICK1X,STICK1Z1,STICK1X1,STICK1Z2,STICK1X2,PEDALL,PEDALR,PEDALBOTH;
UINT MAIN,MAINVC, BLADE,DISC;
MESHHANDLE TUBE;

VECTOR3 CAM_pos;

int iActiveDockNumber,doorselected;





//void Estado();
// UMMU 2.0 DECLARATION
	UMMUCREWMANAGMENT Crew;
	int SelectedUmmuMember;				// for the SDK demo, select the member to eva
	int iActionAreaDemoStep;			// this is just to show one feature of action area.
	void clbkSetClassCaps_UMMu(void);	// our special SetClassCap function just added for more readability

	// The HUD display method variable, see PDF doc
	char cUmmuHudDisplay[255];			// UMmu hud char variable
	double dHudMessageDelay;			// UMmu hud display delay
	char *SendHudMessage(void);			// UMmu hud display function

	// THIS IS FOR ADDING CREW SEE PDF doc "Allow user to add crew to your ship 
	// without scenery editor"
	char cAddUMmuToVessel[255];
	void AddUMmuToVessel(BOOL bStartAdding=FALSE);

// UCGO SPECIFIC CODE OF CLASS HEADER **********************************

	void clbkSetClassCapsUCgo (void); // a custom UCGO clbkSetClassCap just to keep code clear

	// UCGO 2.0 CLASS HANDLE FUNCTION AND VARIABLES
	UCGO	hUcgo;						// Cargo class handle
	char   *SendCargHudMessage(void);	// Cargo hud display function
	char	cCargoHudDisplay[255];		// Cargo hud display char variable
	double	dCargHudMessageDelay;		// Cargo hud display delay
	int		iSelectedCargo;				// for the selection of cargos -1 by default






private:
int BELL222ID,SPEED,CAM;
VECTOR3 P1_pos,P2_pos;
double WINCH_SPEED;
UINT anim_STICKZ;
UINT anim_STICKZ1;

UINT anim_STICKX;
UINT anim_STICKX1;
UINT anim_STICKZ2;
UINT anim_STICKZ3;

UINT anim_STICKX2;
UINT anim_STICKX3;

UINT anim_PEDAL1;
UINT anim_PEDAL2;


UINT anim_COLL;
UINT anim_GEAR2;

UINT anim_GEAR;
//UINT anim_GEARCOVER;
UINT anim_RAMP;
UINT anim_RAMP2;
UINT anim_ROTOR2;
UINT anim_ROTOR3;

UINT anim_ROTOR;
UINT anim_ROTOR1;
UINT anim_DOOR1;
UINT anim_DOOR2;
UINT anim_DOOR3;
UINT anim_DOOR4;

UINT anim_GEARIND1;
UINT anim_GEARIND2;
UINT anim_GEARIND3;
UINT anim_GEARIND4;

UINT anim_CABLE;
UINT anim_CABLE1;
UINT anim_CABLE2;
UINT anim_CABLE3;

VECTOR3 beaconpos[5];
VECTOR3 beaconcol[5];
BEACONLIGHTSPEC beacon[5];


};
